import java.io.*;

/**
 * Diese Klasse erleichtert das Einlesen von der Standardeingabe,
 * indem sie daf&uuml;r einige Methoden zur Verfuegung stellt. <br><br>
 * Die Methoden <em>typ</em>Einlesen lesen jeweils eine
 * Variable vom Typ <em>typ</em> von der Standardeingabe ein und
 * behandeln dabei die Fehler, die beim Einlesen und Umwandeln des
 * Eingabestrings in den Typ <em>typ</em> enstehen k&ouml;nnen.
 * Die Methoden bekommen jeweils einen String als Parameter
 * (aufforderungsString) &uuml;bergeben. Dieser String wird
 * auf die Standardausgabe ausgegeben und dient dazu, dem Benutzer
 * mitzuteilen, welche Eingabe erwartet wird. Das Einlesen
 * wird jeweils solange wiederholt, bis beim Einlesen kein Fehler
 * mehr auftritt, insbesondere die Eingabe vom Typ <em>typ</em> ist.
 */
public class Eingabe {

/**Die Mehtode <b>stringEinlesen</b> erm&ouml;glicht Tastatureingabe ber die Konsole. Die Programmausf&uuml;hrung wird mit einem
**Bildschirmprompt solange angehalten, bis eine Tastatureingabe ber die Konsole erfolgt und erfolgreich mit RETURN best&auml;tigt wurde.
@param aufforderungsString - mit diesem Text wird der Benutzer aufgefordert eine Eingabe zu machen.
@return Die Zeichenkette, die der Benutzer &uuml;ber die Konsole eingegeben hat.*/

  public static String stringEinlesen ( String aufforderungsString ) {
    String eingabeString = "";
    boolean fehler; 
    BufferedReader console =
      new BufferedReader( new InputStreamReader( System.in ) );
    do {
      fehler = false;
      System.out.print( aufforderungsString );
      try {
            eingabeString = console.readLine( );
           }
      catch (IOException ioexception) {
            fehler = true;
            System.out.println( "Fehler beim Einlesen aufgetreten: "+ ioexception.getMessage() );
           }
    }  while (fehler);
    return eingabeString;
  }

/**Die Mehtode <b>intEinlesen</b> erm&ouml;glicht Tastatureingabe ber die Konsole. Die Programmausf&uuml;hrung wird mit einem
**Bildschirmprompt solange angehalten, bis eine Tastatureingabe ber die Konsole erfolgt und erfolgreich mit RETURN best&auml;tigt wurde.
**Die Eingabe wird solange wiederholt, bis eine gltige ganze Zahl aus der Tastatureingabe erzeugt werden kann.
@param aufforderungsString - mit diesem Text wird der Benutzer aufgefordert eine Eingabe zu machen.
@return Der Integerwert, die der Benutzer &uuml;ber die Konsole eingegeben hat.*/

  public static int intEinlesen ( String aufforderungsString ) {
    String eingabeString = "";
    int eingabeZahl = 0;
    boolean fehler; 
    BufferedReader console =
      new BufferedReader( new InputStreamReader( System.in ) );

    do {
      fehler = false;
      System.out.print( aufforderungsString );
      try {
        eingabeString = console.readLine();
        eingabeZahl = Integer.parseInt( eingabeString );
      }
      catch (IOException ioexception) {
        fehler = true;
        System.out.println("Fehler beim Einlesen aufgetreten: "+ ioexception.getMessage() );
      }
      catch (NumberFormatException numberformatexception) {
        fehler = true;
        System.out.println("Sie muessen eine ganze Zahl eingeben, deren " +"Betrag kleiner oder gleich " + Integer.MAX_VALUE + " ist!");
      }
    }
    while (fehler);
    return eingabeZahl;
  }
} 

